Title Add symmetries pruning support
Priority feature Status chatting
Superseder Nosy List jendrik, malte, mkatz, nirp
Assigned To nirp Keywords
Optional summary

Created on 2011-08-25.16:13:59 by nirp, last changed by mkatz.

msg1741 (view) Author: malte Date: 2011-09-05.13:28:45
Results for the bug-fixed code are in, and there are no more invalid plans:
msg1740 (view) Author: malte Date: 2011-09-04.20:24:15
Results of first experiment with optimized code:

Compare with the following to see the non-optimized vs. optimized difference:

Coverage and expansions remained essentially the same, but speed is improved.

This still has the invalid plans, but experiments with the fixed code have been
started. (This time I did not run the no-symmetry configs, though. Hope the fix
cannot affect those adversely.)
msg1739 (view) Author: nirp Date: 2011-09-04.14:13:29
I uploaded a new version which should fix the bug (tested on at least one problem 
that previously failed with each heuristic).
msg1738 (view) Author: malte Date: 2011-09-03.23:42:06
Results of second experiment with optimized code are in:

Compare with the following to see the non-optimized vs. optimized difference:

Having looked at the summary coverage and score_total_time data, this indeed
looks much improved! :-)
msg1737 (view) Author: nirp Date: 2011-09-03.23:37:21
It's the same with the logistics00 example with LM-CUT.
I think that something is not updated right in the node/node_info when a state 
from the same orbit as a state that is already in the open list is reached with a 
better f-value, but I'm not sure, and still looking into it.
msg1736 (view) Author: malte Date: 2011-09-03.22:58:34
I looked at the invalid plan, and it could be repaired by replacing some of the
operators by symmetric operators, so it looks like this should be fixable (at
least from this example).
msg1735 (view) Author: malte Date: 2011-09-03.16:17:07
Update: I have looked into the Peg Solitaire #25 validation failure with blind
search and can reproduce it, both with the old code (revision 9edab9ae17f9) and
the current one (revision 2bf9bb7ca79e). The problem is solved in less than 10
seconds and only has one generator, so hopefully it should not be too hard to
debug it.

(Nir, if you want to run the standard validator on this, you maybe first have to
need to remove the string "- number" from the domain file or VAL will crash. At
least my copy does, but I'm not sure if it's the newest version. This does not
affect the semantics of the domain, as "- number" is the default anyway.)
msg1734 (view) Author: malte Date: 2011-09-03.14:55:10
Thanks, Jendrik!

Nir, I've started experiments with the optimized code (revision 2bf9bb7ca79e).

In the meantime, the other experiment with the less optimized code (revision
9edab9ae17f9) has completed, but unfortunately it shows validation errors with
the symmetry configs:

The section of interest is "validate_error"; the first, much smaller HTML file
shows per-domain summaries, the second, huge one shows individual results.

Examples of tasks where solutions failed to validate include:
- with blind search: Pegsol #25
- with LM-cut: Logistics00 #10-0, Pegsol #25
- with m&s: Miconic #8-3, Logistics98 #01

(That's not a complete list; I selected ones that are maybe potentially easier
to work with than some of the others.)
msg1730 (view) Author: jendrik Date: 2011-09-02.19:55:02
This should be fixed now.
msg1729 (view) Author: nirp Date: 2011-09-02.16:21:00
A much optimized version is now available.
msg1727 (view) Author: malte Date: 2011-09-01.21:49:54
Jendrik: the score_search_time in the per-domain link in the previous message
looks wrong. For example, in assembly it's 100 even though nothing is solved,
and more generally all the scores look much too high. They should be much closer
to score_total_time.
msg1726 (view) Author: malte Date: 2011-09-01.21:48:42
Results of the second part of the experiment are in and not looking bad, I
think. :-)  mostly looked at the overall coverage results so far. See the first
link for per-domain summaries and the second for per-problem results.
Date User Action Args
2011-10-26 09:20:23mkatzsetnosy: + mkatz
2011-09-05 13:28:45maltesetmessages: + msg1741
2011-09-04 20:24:16maltesetmessages: + msg1740
2011-09-04 14:13:30nirpsetmessages: + msg1739
2011-09-03 23:42:06maltesetmessages: + msg1738
2011-09-03 23:37:21nirpsetmessages: + msg1737
2011-09-03 22:58:35maltesetmessages: + msg1736
2011-09-03 16:17:07maltesetmessages: + msg1735
2011-09-03 14:55:11maltesetmessages: + msg1734
2011-09-02 19:55:02jendriksetmessages: + msg1730
2011-09-02 16:21:00nirpsetmessages: + msg1729
2011-09-01 21:49:54maltesetnosy: + jendrik
messages: + msg1727
2011-09-01 21:48:43maltesetstatus: unread -> chatting
messages: + msg1726
2011-08-25 16:13:59nirpcreate